/*******************************************************************************
 *
 * blueMarine - open source photo workflow
 * =======================================
 *
 * Copyright (C) 2003-2009 by Fabrizio Giudici
 * Project home page: http://bluemarine.tidalwave.it
 *
 *******************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 *
 *******************************************************************************
 *
 * $Id: TimestampProviderImpl.java,v d60681e7fc1d 2009/09/17 23:59:23 fabrizio $
 *
 ******************************************************************************/
package it.tidalwave.metadata.impl;

import it.tidalwave.metadata.TimestampProvider;
import java.util.Date;
import javax.annotation.Nonnull;

/*******************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: TimestampProviderImpl.java,v d60681e7fc1d 2009/09/17 23:59:23 fabrizio $
 *
 ******************************************************************************/
public class TimestampProviderImpl implements TimestampProvider
  {
    private final ThreadLocal<Date> dateHolder = new ThreadLocal<Date>();
    
    @Nonnull 
    public Date getTimestamp()
      {
        return new Date();
      }
    
    @Nonnull 
    public Date getSampledTimestamp() 
      {
        if (dateHolder.get() == null)
          {
            sample();
          }
        
        return new Date(dateHolder.get().getTime());
      }
    
    @Nonnull 
    public Date sample()
      {
        final Date now = new Date();
        dateHolder.set(now);
        return new Date(now.getTime());
      }
  }
